/*

Saturday
--------
13:00  woke up after some 9 hours of sleep, thought of an idea last night
14:00  breakfast, droozing around on irc and compo site, watching other people's stuff
15:00  shower
16:00  decided to do some coding before getting proper food
17:00  main framework done, going for dense and compact code
18:00  mainly idle now, stummy says I better get food soon (started this log, so previous times are approximate)
19:00  ate some food, idling... got isometric tile drawing, not quite sure how to proceed
19:30  got off my hiney and drew a placeholder player, let's get it moving on the map
23:00  oh boy, time flies... acquired some sugary treats from the shop, and the player is mostly working
02:30  hum di dee, sporadic coding work has yielded acceptable map navigation in terms of walking and jumping

Sunday
------
08:50  hooray, managed not to oversleep! let's see if that idea I had last night about z ordering will work...
08:51  ...and it seems to do just that! joy and extacy ensues... but yeah, it was kind of bugging me
10:40  larger level and scrolling, spent a good hour trying to find a scroll bug that turned out to be a one-character typo
11:00  made four simple variations of the placeholder player sprite to indicate direction - made much more of a difference than I expected!
11:40  wasting time, might be getting hungry... should probably eat a little (and plan my next move)
12:30  no longer hungry, scribbled some todo on paper, will start on specific-ish gameplay elements
13:30  wait, what was that I was going to do now?
14:55  right, another item checked off... this time it's my main gameplay feature, the floodfill (still wasting time)
15:10  spent a while adding a fancy flashing phase for the filling tiles, totally worth it - looks less drab (next: pick up & carry objects)
15:55  oops, showered... (next: still pick up & carry)
16:55  might drop that feature actually, and instead go for a more solo-oriented gameplay where you directly affect the map by jumping/landing on it
18:05  there is jumping! (and food)
18:35  burp... what's next? oh, affecting the level with your jumps... not quite sure exactly how to do it, either single-tile or multi-tile
18:55  might have had a more concrete idea on how the gameplay could work out in terms of challenge... it would be puzzly, and maybe hard to make levels for, but it could work
19:15  hmm, that might be a bit too crazy... the player currently auto-swaps between raising/lowering the tile you land on, including neighbors - also I need to fix tall tiles :/
20:00  argh, tall tiles are killing me here... should I keep pushing on and hope to eventually fix it, or just give up and resort to having only +/- 1 tile height differences?
20:20  ok, that'll work - you can make nice landscapes with it :)
22:05  ark! this is not going well... making nice landscapes is not a chain reaction, and all attempts to make anything with the graphics have failed miserably - again: what to do?
23:25  trying to salvage what's there by drawing some gfx, player sprite turned out crazy so that's a good start... not sure about the tiles, could work the way they are

*/

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <string.h>

#include "playmu/playmu.h"

#define rnd(n) (rand()%(n+1))

#include "ptc/tinyptc.h"
#define DWORD unsigned int
static DWORD ptc_screen[640*480];

int scrollx=0, scrolly=0;

#include "tools.h"

char scrollmsg[2048]=" YIKES! TIME TIME TIME... WELL - I GOT MYSELF A SINE SCROLLER AFTER ALL - AND SOME CRAP MUSIC.         "
					 " CONTROLS - ARROWS TO MOVE  ...  Z TO JUMP  ...  X TO FLOODFILL  ...  Z IN MID-JUMP TO CHARGE         "
					 "ACTUALLY THE TIME IS UP NOW - BUT PHIL GAVE ME ANOTHER 5 MINUTES TO WRITE THIS. THAT IS SO WORTH A TROPHY!         "
					 "WELL I GOTTA GIVE A SHOUT OUT TO X-0UT.S SCROLLER NOW THAT I AM TYPING - US SCROLLERS WE ARE A TIGHT CREW!        "
					 "OK - CANNOT PUSH IT ANY LONGER... NEED TO SUBMIT....       LD48 FTWZORZ!          "
					 "PROPS TO THE PEOPLE WHO ACTUALLY MADE GAMES!!!                          ";
int smlen;

Image cube[2];
Image cube_white;
Image water;
Image player[4];
Image shadow[2];
Image arrow[2];

playmu_sound sfx_start;
playmu_sound sfx_activate;
playmu_sound sfx_mutate;
playmu_sound sfx_jump;
playmu_sound sfx_land;
playmu_sound sfx_die;
playmu_sound sfx_dead;
playmu_sound sfx_morph;
playmu_sound sfx_charge;
//playmu_sound sfx_;

struct IsoObject { int x, y, z, fz, fdz, size; bool stood, jumped; };
IsoObject iobjs[1024];
int num_iobjs=0;

struct MapTile { int height, type, ptype, state1, state2; };
MapTile map[40*40];
MapTile dummytile;
int mapsize=40;

int flood_delay=-1;
int flood_type=0;

IsoObject po;
int jumpmode=1;
bool charged=false;
int scrollerx;

MapTile& GetMap(int x, int y)
{
	x/=32; y/=32;
	if(x<0 || y<0 || x>=mapsize || y>=mapsize) return dummytile;
	return map[y*mapsize+x];
}

void InitFlood(int x, int y, int ttype)
{
	playmu_playsound(sfx_activate, 60);
	for(int i=0;i<mapsize*mapsize;i++)
		map[i].state1=0;
	map[y/32*mapsize+x/32].type=ttype;
	map[y/32*mapsize+x/32].state1=2;
	flood_delay=30;
	flood_type=ttype;
}

void EndFlood()
{
	for(int i=0;i<mapsize*mapsize;i++)
		map[i].ptype=map[i].type;
	flood_delay=-1;
}

bool FloodMap(int ttype)
{
	bool filled=false;
	bool mutated=false;
	for(int y=1;y<mapsize-1;y++)
		for(int x=1;x<mapsize-1;x++)
		{
			MapTile* ctile=&map[y*mapsize+x];
			if(ctile->type==ttype) continue;
			bool fill=false;
			MapTile* tile;
			tile=&map[(y+0)*mapsize+(x+1)]; if(tile->state1>1 && tile->height==ctile->height) fill=true;
			tile=&map[(y+0)*mapsize+(x-1)]; if(tile->state1>1 && tile->height==ctile->height) fill=true;
			tile=&map[(y+1)*mapsize+(x+0)]; if(tile->state1>1 && tile->height==ctile->height) fill=true;
			tile=&map[(y-1)*mapsize+(x+0)]; if(tile->state1>1 && tile->height==ctile->height) fill=true;
			if(fill)
			{
				ctile->type=ttype;
				ctile->state1=1;
				filled=true;
				mutated=true;
			}
		}
	for(int i=0;i<mapsize*mapsize;i++)
		if(map[i].state1>0 && map[i].state1<5) { map[i].state1++; filled=true; if(map[i].state1==5) map[i].ptype=map[i].type; }
	if(mutated) playmu_playsound(sfx_mutate, 60);
	return filled;
}

void FixMap()
{
	bool ok=false;
	while(!ok)
	{
		ok=true;
		for(int y=1;y<mapsize-1;y++)
			for(int x=1;x<mapsize-1;x++)
			{
				MapTile* ctile=&map[y*mapsize+x];
				if(ctile->state2==9) continue; // locked
				int maxh=ctile->height;
				int minh=maxh;
				MapTile* tile;
				tile=&map[(y+0)*mapsize+(x+1)]; maxh=imax(maxh, tile->height); minh=imin(minh, tile->height);
				tile=&map[(y+0)*mapsize+(x-1)]; maxh=imax(maxh, tile->height); minh=imin(minh, tile->height);
				tile=&map[(y+1)*mapsize+(x+0)]; maxh=imax(maxh, tile->height); minh=imin(minh, tile->height);
				tile=&map[(y-1)*mapsize+(x+0)]; maxh=imax(maxh, tile->height); minh=imin(minh, tile->height);
				if(ctile->height<maxh-16) { ctile->height+=16; ok=false; }
				else if(ctile->height>minh+16) { ctile->height-=16; ok=false; }
			}
	}
	for(int i=0;i<mapsize*mapsize;i++)
	{
		map[i].state2=0;
		if(map[i].type==0 && map[i].height>0) { map[i].type=1; map[i].state1=0; map[i].ptype=map[i].type; }
	}
}

void MoveTile(int x, int y, int dir)
{
	map[y*mapsize+x].height+=dir*16;
	if(map[y*mapsize+x].height<0) map[y*mapsize+x].height=0;
	map[y*mapsize+x].state2=9; // lock
}

void MoveObject(IsoObject& obj)
{
	obj.fdz-=32;
	obj.fz+=obj.fdz;
	obj.z=obj.fz>>8;
	int maxz=0;
	maxz=imax(maxz, GetMap(obj.x-obj.size,obj.y-obj.size).height);
	maxz=imax(maxz, GetMap(obj.x-obj.size,obj.y+obj.size).height);
	maxz=imax(maxz, GetMap(obj.x+obj.size,obj.y-obj.size).height);
	maxz=imax(maxz, GetMap(obj.x+obj.size,obj.y+obj.size).height);
	if(maxz>obj.z)
	{
		if(!obj.stood) playmu_playsound(sfx_land, 90);
		if(!obj.stood && charged)
		{
			playmu_playsound(sfx_morph, 30);
			charged=false;
			MoveTile(obj.x/32, obj.y/32, jumpmode);
			FixMap();
			jumpmode=-jumpmode;
		}
		obj.z=maxz; obj.fz=obj.z<<8; obj.fdz=0; obj.stood=true;
	} else obj.stood=false;
}

void GReset()
{
	// player	
	po.x=32*15+16; po.y=32*27+16; po.z=16*8;
	po.fz=po.z<<8; po.fdz=0;
	po.size=6;
	po.stood=false;
	charged=false;
	jumpmode=-1;

	dummytile.height=0;
	dummytile.type=0;
	for(int y=0;y<mapsize;y++)
		for(int x=0;x<mapsize;x++)
		{
			int i=y*mapsize+x;
			map[i].height=0;
			map[i].type=0;
			map[i].state1=0;
			map[i].state2=0;
			int sx=x-mapsize/2;
			int sy=y-mapsize/2;
			if(sqrt((float)(sx*sx+sy*sy))<13.5f) { map[i].height=1*16; map[i].type=1; }
			if(sqrt((float)(sx*sx+sy*sy))<10.2f) { map[i].height=2*16; map[i].type=1; }
			if(sqrt((float)(sx*sx+sy*sy))<7.2f) { map[i].height=3*16; map[i].type=1; }
			if(sqrt((float)(sx*sx+sy*sy))<5.7f) { map[i].height=0; map[i].type=0; }
			if(sx==0 && sy==0) { map[i].height=3*16; map[i].type=2; }
			if((x&7)==0 && map[i].height!=0) map[i].height+=16;
			if(sx==0 && map[i].height!=0) map[i].height+=32;
			map[i].ptype=map[i].type;
		}
	FixMap();
	EndFlood();
}

void main()
{
	srand(time(NULL));

	if(!ptc_open("ld10", 640, 480))
		return;

	check(LoadPNG(cube[0], "cube-color2.png"));
	check(LoadPNG(cube[1], "cube-color3.png"));
	check(LoadPNG(cube_white, "cube-white.png"));
	check(LoadPNG(water, "water.png"));
	check(LoadPNG(player[0], "player2_left.png"));
	check(LoadPNG(player[1], "player2_right.png"));
	check(LoadPNG(player[2], "player2_up.png"));
	check(LoadPNG(player[3], "player2_down.png"));
	check(LoadPNG(shadow[0], "shadow1.png"));
	check(LoadPNG(shadow[1], "shadow2.png"));
	check(LoadPNG(arrow[0], "adown.png"));
	check(LoadPNG(arrow[1], "aup.png"));

	check(LoadPNG(font, "font.png"));
	check(LoadPNG(gradient, "gradient.png"));

	smlen=(int)strlen(scrollmsg);

	SetEnvironmentVariable("PA_MIN_LATENCY_MSEC", "75");
	playmu_init();
	playmu_mastervolume(100);
	check(playmu_loadsound(sfx_start, "sfx\\start.wav", 1));
	check(playmu_loadsound(sfx_activate, "sfx\\activate.wav", 1));
	check(playmu_loadsound(sfx_mutate, "sfx\\crunch.wav", 1));
	check(playmu_loadsound(sfx_jump, "sfx\\jump.wav", 1));
	check(playmu_loadsound(sfx_land, "sfx\\land.wav", 1));
	check(playmu_loadsound(sfx_die, "sfx\\die.wav", 1));
	check(playmu_loadsound(sfx_dead, "sfx\\dead.wav", 1));
	check(playmu_loadsound(sfx_morph, "sfx\\badoom.wav", 1));
	check(playmu_loadsound(sfx_charge, "sfx\\charge.wav", 1));
//	check(playmu_loadsound(sfx_, "sfx\\.wav", 1));
	check(playmu_loadsong("sfx\\ld10.smu"));
	playmu_playsong(0);
	playmu_songvolume(140);

	GReset();

	scrollerx=-350;

//	playmu_playsound(sfx_start, 60);

	float water_phase=0.0f;
	int counter=0;	
	int dir=3;
	int dead_delay=0;
	for(;;)
	{
		if(dead_delay>0)
		{
			dead_delay--;
			if(dead_delay==0) { dead_delay=0; GReset(); }
		}
		else
		{
			if(po.z<=0 && po.stood && GetMap(po.x, po.y).type==0)
			{
				playmu_playsound(sfx_die, 50);
				dead_delay=60;
			}
	
			if(KeyPressed(KEY_MENU)) break;
			if(KeyPressed(KEY_A))
			{
				if(!po.jumped && !po.stood && !charged) { charged=true; playmu_playsound(sfx_charge, 40); }
				if(!po.jumped && po.stood) { po.fdz=3<<8; playmu_playsound(sfx_jump, 50); }
				po.jumped=true;
			}
			else
				po.jumped=false;
			if(KeyPressed(KEY_B) && po.stood && flood_delay==-1 && GetMap(po.x, po.y).type==1)
				InitFlood(po.x, po.y, 2);
	
			// movement (done twice to get 2 steps/frame without walking through walls)
			for(int i=0;i<2;i++)
			{
				int dx=0, dy=0;
				if(KeyPressed(KEY_UP))    { dx-=1; dy-=1; dir=2; }
				if(KeyPressed(KEY_DOWN))  { dx+=1; dy+=1; dir=3; }
				if(KeyPressed(KEY_LEFT))  { dx-=1; dy+=1; dir=0; }
				if(KeyPressed(KEY_RIGHT)) { dx+=1; dy-=1; dir=1; }
				// limit "diagonal" (visually orthogonal) movement speed
				bool diag=false;
				if(abs(dx)==2) { dx/=2; diag=true; }
				if(abs(dy)==2) { dy/=2; diag=true; }
				if(i==1 && !diag) break;
				// collide
				if(dx<0 && (GetMap(po.x-8, po.y-7).height>po.z||GetMap(po.x-8, po.y+7).height>po.z)) dx=0;
				if(dx>0 && (GetMap(po.x+8, po.y-7).height>po.z||GetMap(po.x+8, po.y+7).height>po.z)) dx=0;
				if(dy<0 && (GetMap(po.x-7, po.y-8).height>po.z||GetMap(po.x+7, po.y-8).height>po.z)) dy=0;
				if(dy>0 && (GetMap(po.x-7, po.y+8).height>po.z||GetMap(po.x+7, po.y+8).height>po.z)) dy=0;
				po.x+=dx;
				po.y+=dy;
			}
	
			MoveObject(po);
	
			int stx=IsoX(po.x, po.y, po.z)+32;
			int sty=IsoY(po.x, po.y, po.z)+32;
	
			if(stx-128<scrollx) scrollx=stx-128;
			if(stx+128>scrollx+320) scrollx=stx+128-320;
			if(sty-110<scrolly) scrolly=sty-110;
			if(sty+80>scrolly+240) scrolly=sty+80-240;
		}
	
		counter++;

		if(flood_delay>-1)
		{
			flood_delay--;
			if(flood_delay==0)
			{
				flood_delay=10;
				if(!FloodMap(flood_type))
					EndFlood();
			}
		}

		water_phase+=0.06f;
		for(int y=0;y<mapsize;y++)
			for(int x=0;x<mapsize;x++)
			{
				int wh=(int)(sin((float)x*0.32f+water_phase)*2+2);
				int mi=y*mapsize+x;
				if(map[mi].type==0)
					DrawIso(water, x*32, y*32, wh, false, false);
				else
					DrawIso(cube[map[mi].type-1], x*32, y*32, map[mi].height, false, ((counter&2) && map[mi].ptype!=map[mi].type));
			}

		int pmi=po.y/32*mapsize+po.x/32;
		int mheight=map[pmi].height;
		if(counter&1)
			DrawIso(shadow[1], po.x-16, po.y-16, mheight, true, false);
		DrawIso(player[dir], po.x-16, po.y-16, po.z+1, true, (counter&2)&&(charged|dead_delay>0));

		FlushIso();
		
		DrawImage(arrow[jumpmode==-1?0:1], 144, 190, false);
		
		ClearFXBuffer();
		DrawString(scrollmsg, smlen, scrollerx);
		Overlay();
		scrollerx+=2;
		UpdateScreen(true);
		ptc_update(ptc_screen);
		Sleep(10);
	}
	playmu_fadeout(500);
	Sleep(500);
	playmu_close();
	Quit();
}

